package it.unibo.lbedogni.datamanagement;

import android.arch.persistence.room.Room;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.Button;

import java.util.ArrayList;
import java.util.List;

import it.unibo.lbedogni.datamanagement.it.unibo.lbedogni.datamanagement.room.AppDatabase;
import it.unibo.lbedogni.datamanagement.it.unibo.lbedogni.datamanagement.room.User;
import it.unibo.lbedogni.datamanagement.it.unibo.lbedogni.datamanagement.room.UserDao;

public class RoomDatabaseActivity extends AppCompatActivity implements View.OnClickListener {

    AppDatabase db;
    Button btnAddUser;
    RecyclerView rv;
    Button btnShowData;

    ArrayList<String> allUsers;

    RvHandler myAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_room_database);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        allUsers = new ArrayList<String>();

        btnAddUser = (Button)findViewById(R.id.btnAddUser);
        btnShowData = (Button)findViewById(R.id.btnShowData);
        rv = (RecyclerView)findViewById(R.id.rvMain);

        myAdapter = new RvHandler(allUsers);
        rv.setLayoutManager(new LinearLayoutManager(getApplicationContext()));
        rv.setAdapter(myAdapter);

        btnAddUser.setOnClickListener(this);
        btnShowData.setOnClickListener(this);

        db = Room.databaseBuilder(getApplicationContext(),
                AppDatabase.class, "myDatabase").allowMainThreadQueries().build();

    }

    @Override
    public void onClick(View v) {
        if (v == btnAddUser) {
            User u = new User();
            u.setFirstName("Luca");
            u.setLastName("Bedogni");
            insertItem(u);
        } else if (v == btnShowData) {
            allUsers.clear();
            myAdapter.notifyDataSetChanged();
            List<User> myUsers = db.userDao().getAll();
            for (int i = 0; i < myUsers.size(); i++) {
                allUsers.add(String.valueOf(myUsers.get(i).getUid()) + ": " + myUsers.get(i).getFirstName() + " " + myUsers.get(i).getLastName());
                myAdapter.notifyItemInserted(i);
            }
        }
    }

    private void insertItem(final User u) {
        final UserDao agentDao = db.userDao();
        new AsyncTask<Void, Void, Void>() {
            @Override
            protected Void doInBackground(Void... params) {
                agentDao.insertAll(u);
                return null;
            }
        }.execute();
    }
}
