package it.unibo.lbedogni.datamanagement;

import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.Html;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

public class Thirty extends AppCompatActivity implements OnClickListener {

    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
    	setContentView(R.layout.database_main);
    	
    	TextView tvMain = (TextView)findViewById(R.id.tv_main);
        tvMain.setText(Html.fromHtml("Below you see all the students that got 30 in any course"));
    	
    	DBHelper dbh = DatabaseActivity.getDBHelper();
         
 		LinearLayout ll = (LinearLayout)findViewById(R.id.mainLayout);

        Cursor cursor = dbh.get30();
        cursor.moveToFirst();
              
 		while (!cursor.isAfterLast()) {
 			
 			TextView tv = new TextView(this);
 			LayoutParams lp = new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
 			tv.setLayoutParams(lp);
 			
 			LinearLayout newLL = new LinearLayout(this);
 			LayoutParams newLP = new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT);
 			newLL.setLayoutParams(newLP);
 			newLL.setOrientation(LinearLayout.HORIZONTAL);
 			
 			int id = cursor.getInt(cursor.getColumnIndex(DBHelper.COLUMN_ID));
 			String firstName = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_FIRST_NAME));
 			String lastName = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_LAST_NAME));
 			String className = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_CLASS));
 			String grade = cursor.getString(cursor.getColumnIndex(DBHelper.COLUMN_GRADE));
 			
 			String toWrite = firstName + " " + lastName + " - " + className + " - " + grade;
 			
 			tv.setId(id);
 			
 			tv.setText(toWrite);
 			
 			newLL.addView(tv);
 			
 			Button btn = new Button(this);
 			btn.setBackgroundColor(getResources().getColor(android.R.color.holo_red_dark));
 			btn.setText("Delete");
 			btn.setId(id);
 			btn.setLayoutParams(lp);
 			
 			btn.setOnClickListener(this);
 			
 			newLL.addView(btn);
 			
 			ll.addView(newLL);
 			
 			cursor.moveToNext();
 		}
 		cursor.close();
    }

	@Override
	public void onClick(View v) {
		// Get the id from the view
		int id = v.getId();
		DatabaseActivity.getDBHelper().deleteStudent(id);
		
		Intent i = new Intent(this, DatabaseActivity.class);
		startActivity(i);	
	}
}