package it.unibo.lbedogni.datamanagement;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.widget.TextView;

public class mySharedPreferences extends AppCompatActivity {

    private static TextView tvCounter;
    private int counter = 0;

    private static String DATA_MANAGEMENT_SHARED_PREFERENCES = "sharedPreferences";
    private static String SHARED_PREFERENCES_COUNTER = "sharedPreferencesCounter";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_shared_preferences);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        tvCounter = (TextView)findViewById(R.id.tvCounter);

        SharedPreferences sp = getApplicationContext().getSharedPreferences(DATA_MANAGEMENT_SHARED_PREFERENCES, Context.MODE_PRIVATE);
        counter = sp.getInt(SHARED_PREFERENCES_COUNTER,0);
        tvCounter.setText(String.valueOf(counter));

        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Adding one to the counter", Snackbar.LENGTH_LONG)
                        .setAction("UNDO", new View.OnClickListener() {
                            @Override
                            public void onClick(View v) {
                                decreaseCounter();
                            }
                        }).show();
                increaseCounter();
            }
        });
    }

    private void savePreferences() {
        SharedPreferences sp = getApplicationContext().getSharedPreferences(DATA_MANAGEMENT_SHARED_PREFERENCES, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sp.edit();
        editor.putInt(SHARED_PREFERENCES_COUNTER,counter);
        editor.commit();
    }

    private void increaseCounter() {
        counter++;
        tvCounter.setText(String.valueOf(counter));
        savePreferences();
    }

    private void decreaseCounter() {
        counter--;
        mySharedPreferences.tvCounter.setText(String.valueOf(counter));
        savePreferences();
    }

}
